﻿;History
;15-04-2022 bfox reported wrong processing
;16-04-2022 start error colorizing, todo: black correct lines
;17-04-2022 msgbox if errors, push hll - incorrect
Enumeration
  #s1
  #s2
  #bc1
  #bc2
  #opt_com
  #opt_no
  #opt_sp
  #opt_tab
  #lz80
  #l8080
EndEnumeration

Procedure Editor_Color(gad.l,Color.l)
  format.CHARFORMAT
  format\cbSize = SizeOf(CHARFORMAT)
  format\dwMask = #CFM_COLOR
  format\crTextColor = Color
  SendMessage_(GadgetID(gad), #EM_SETCHARFORMAT, #SCF_SELECTION, @format)
EndProcedure

Procedure Editor_Select(Gadget, LineStart.l, CharStart.l, LineEnd.l, CharEnd.l)
  sel.CHARRANGE
  sel\cpMin = SendMessage_(GadgetID(Gadget), #EM_LINEINDEX, LineStart, 0) + CharStart - 1

  If LineEnd = -1
    LineEnd = SendMessage_(GadgetID(Gadget), #EM_GETLINECOUNT, 0, 0)-1
  EndIf
  sel\cpMax = SendMessage_(GadgetID(Gadget), #EM_LINEINDEX, LineEnd, 0)

  If CharEnd = -1
    sel\cpMax + SendMessage_(GadgetID(Gadget), #EM_LINELENGTH, sel\cpMax, 0)
  Else
    sel\cpMax + CharEnd - 1
  EndIf
  SendMessage_(GadgetID(Gadget), #EM_EXSETSEL, 0, @sel)
EndProcedure

Procedure.s mytrim(s.s)
  
  ; Debug s
  p=1;chr(09)
  While p
    p=FindString(s,Chr(09))
    If p
      s=ReplaceString(s,Chr(09)," ")
    EndIf
  Wend
  
  p=1;chr(32)
  While p
    p=FindString(s,"  ")
    If p
      s=ReplaceString(s,"  "," ")
    EndIf
  Wend
  
  ; Debug s
  
  ProcedureReturn s
EndProcedure


Procedure.l chk(r.s,s.s)
  CreateRegularExpression(1, r)
  re.l=MatchRegularExpression(1, LCase(s))
  FreeRegularExpression(1)
  ProcedureReturn re
EndProcedure

Procedure.s cln(s.s)
  s=ReplaceString(s,Chr(9)," ")
  s=RTrim(s)
  While FindString(s,"  ")
  s=ReplaceString(s,"  "," ")
  Wend
    s=ReplaceString(s," , ",",")
    s=ReplaceString(s,", ",",")
    s=ReplaceString(s," ,",",")
    
    s=ReplaceString(s,"( ","(")
    s=ReplaceString(s," )",")")
    ProcedureReturn s
EndProcedure

Procedure convert();convert z80 to 8080
  ClearGadgetItems(#s2)
  ln=CountGadgetItems(#s1);amount of lines
  ernum=0; error counter
  If ln>0
    For i=0 To ln-1
      edc.l=0
      s.s=GetGadgetItemText(#s1,i)
      ;Debug s
      ;комментарии
      l$=""
      co$=""
      p=FindString(s,";")
      If p
        co$=Mid(s,p)
        s=Mid(s,1,p-1)
      EndIf
      
      If Trim( mytrim(s) )=""
        Goto put_n
      EndIf
      ; тест на метки
      If FindString("abcdefghijklmnopqrstuvwxyz",LCase(Mid(s,1,1)),0,#PB_String_NoCase)
; поиск метки
        j=1
        Repeat
          j+1
          If j=Len(s):Break:EndIf
        Until Mid(s,j,1)=Chr(9) Or Mid(s,j,1)=" "
        If j=Len(s)
          l$=s
          s=""
          Goto put_n
        EndIf
        l$=Mid(s,1,j)
        s=Mid(s,j)
;equals
        If FindString(s,"equ",1,#PB_String_NoCase)
          Goto put_n
        EndIf
        If FindString(s,"=",1,#PB_String_NoCase)
          Goto put_n
        EndIf
      EndIf  
      
      
      ss.s=cln(s);remove space etc
      ;IX;IY   i[x|y]?[-|,|+|h|l]
      If chk("i[x|y]?[-|,|+]", s)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}db[\t, ]{1,}", s)
        Goto put_n
      EndIf
      If chk("^[\t, ]{1,}dw[\t, ]{1,}", s)
        Goto put_n
      EndIf
      If chk("^[\t, ]{1,}ds[\t, ]{1,}", s)
        Goto put_n
      EndIf

      ;ld bc,() ld de,() ld sp,() - illegal and ld(),bc de sp;[\t, ]{1,}
      
      If chk("^[\t, ]{1,}ld[\t, ]{1,}sp,hl",ss)
        s=Mid(s,1,FindString(s,"ld",#PB_String_NoCase)-1)+"sphl"
        Goto put_n
      EndIf  
      
      ;ld (NNNN),hl;-shld
      If chk("^[\t, ]{1,}ld[\t, ]{1,}\(.*?\),hl", ss)
        sep.l=FindString(s,"ld",#PB_String_NoCase)-1
        op1.l=1+FindString(s,"(",#PB_String_NoCase)
        op2.l=FindString(s,"),hl",op1,#PB_String_NoCase)
        s=Mid(s,1,sep)+"shld "+Mid(s,op1,op2-op1)
        Goto put_n
      EndIf
      
      ;ld hl,(NNNN) lhld  LD HL,(nn)		16	5	1
      If chk("^[\t, ]{1,}ld[\t, ]{1,}hl,\(.*?\)", ss)
        sep.l=FindString(LCase(s),"ld")-1
        op1.l=4+FindString(s,"hl,(",0,#PB_String_NoCase)
        op2.l=FindString(s,")",op1,#PB_String_NoCase)
        s=Mid(s,1,sep)+"lhld "+Mid(s,op1,op2-op1)
        Goto put_n
      EndIf
      
      ;ld sp,(NNNN)
      If chk("^[\t, ]{1,}ld[\t, ]{1,}sp,\(", ss)
        Goto illo
      EndIf
      
      ;ld hl, bc, de, sp,NNNN
      If chk("^[\t, ]{1,}ld[\t, ]{1,}sp,", ss)
        s=ReplaceString(s,"ld","lxi",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      
      ;ld bc,(NNNN)
      If chk("^[\t, ]{1,}ld[\t, ]{1,}bc,\(", ss)
        Goto illo
      EndIf
      ;ld bc,NNNN ->LXI B,
      If chk("^[\t, ]{1,}ld[\t, ]{1,}bc,", ss)
        s=ReplaceString(s,"ld","lxi",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      
      ;ld de,(NNNN)
      If chk("^[\t, ]{1,}ld[\t, ]{1,}de,\(", ss)
        Goto illo
      EndIf
      ;ld de,NNNN ->LXI D,
      If chk("^[\t, ]{1,}ld[\t, ]{1,}de,", ss)
        s=ReplaceString(s,"ld","lxi",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"de","d",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      ;ld hl,NNNN->LXI H,
      If chk("^[\t, ]{1,}ld[\t, ]{1,}hl,", ss)
        s=ReplaceString(s,"ld","lxi",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"hl","h",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      
      ;ld a,(de) ld a,(bc) ld (de),a ld (bc),a
      If chk("^[\t, ]{1,}ld[\t, ]{1,}\(bc\),a", ss)
        s=ReplaceString(s,"ld","stax",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"(bc),a","b",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      If chk("^[\t, ]{1,}ld[\t, ]{1,}\(de\),a", ss)
        s=ReplaceString(s,"ld","stax",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"(de),a","d",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      If chk("^[\t, ]{1,}ld[\t, ]{1,}a\,[\t, ]{0,}\(bc\)", ss)
        s=ReplaceString(s,"ld","ldax",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"a,","",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"(bc)","b",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      If chk("^[\t, ]{1,}ld[\t, ]{1,}a\,[\t, ]{0,}\(de\)", ss)
        s=ReplaceString(s,"ld","ldax",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"a,","",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"(de)","d",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf
      
      ;mov/mvi    ld (hl),  
      If chk("^[\t, ]{1,}ld[\t, ]{1,}", ss)
        ;registers
        If chk("ld[\t, ]{1,}\(hl\),[a|b|c|d|e|h|l|]",ss)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase);add a,(hl) add m
          s1.s=UCase( Mid( s,1+FindString(s,",") ) )
          ;обрезать хвост
          If Len(s1)>1
            If Mid(s1,2,1)=" " Or Mid(s1,2,1)=Chr(9)
              s1=Mid(s1,1,1)
            EndIf
          EndIf
          
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L"
            s=ReplaceString(s,"ld","mov",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"ld","mvi",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
        EndIf
      EndIf
      
; LD A,(nn)		13	4	1
      ;ld a,(a16)|ld (a16),a - LDA STA
      If chk("^[\t, ]{1,}ld[\t, ]{1,}a,\(.*?\)", ss) And FindString(s,"(hl)",0,#PB_String_NoCase)=0
        sep.l=FindString(LCase(s),"ld")-1
        op1.l=3+FindString(LCase(s),"a,(")
        op2.l=FindString(s,")",op1,#PB_String_NoCase)
        If LCase(Mid(s,op1,op2-op1))<>"hl"
          s=Mid(s,1,sep)+"lda "+Mid(s,op1,op2-op1)
          Goto put_n
        EndIf
      EndIf
      If chk("^[\t, ]{1,}ld[\t, ]{1,}\(.*?\),a", ss) And FindString(s,"(hl)",0,#PB_String_NoCase)=0
        sep.l=FindString(LCase(s),"ld")-1
        op1.l=1+FindString(s,"(",#PB_String_NoCase)
        op2.l=FindString(LCase(s),"),a",op1)
        If LCase(Mid(s,op1,op2-op1))<>"hl"
          s=Mid(s,1,sep)+"sta "+Mid(s,op1,op2-op1)
          Goto put_n
        EndIf
      EndIf
      
;       ld a, NN -ld [a|b|c|d|e|h|l],?.*
      If chk("^[\t, ]{1,}ld[\t, ]{1,}",ss)
        ;(hl)->m
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        If chk("ld[\t, ]{1,}[a|b|c|d|e|h|l|m]\,",ss)
          j=FindString(s,",",0,#PB_String_NoCase)+1
          s1.s=UCase(Mid(s,j))
          ;обрезать хвост
          If Len(s1)>1
            If Mid(s1,2,1)=" " Or Mid(s1,2,1)=Chr(9)
              s1=Mid(s1,1,1)
            EndIf
          EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"ld","mov",#PB_String_NoCase,1,1)
            Goto put_n
          Else
          If s1="R" Or s1="I"
            Goto illo
          EndIf
            s=ReplaceString(s,"ld","mvi",#PB_String_NoCase)
            Goto put_n
          EndIf
        EndIf
      EndIf
      
      ;XCHG  EX DE,HL
      If chk("^[\t, ]{1,}ex[\t, ]{1,}de,hl",ss)
        s=Mid(s,1,FindString(s,"ex",#PB_String_NoCase)-1)+"xchg"+Mid(s,FindString(s,"hl",#PB_String_NoCase)+2)
        Goto put_n
      EndIf
      
      ;XTHL  EX (SP),HL, correct is ^[\t, ]{1,}ex[\t\s]{1,}\(sp\), hl
      ;If chk("^[\t, ]{1,}ex[\t, ]{1,}\(sp\)\,hl",ss)
      If chk("^[\t, ]{1,}ex[\t\s]{1,}\(sp\)\,hl",ss)
        s=Mid(s,1,FindString(s,"ex",#PB_String_NoCase)-1)+"xthl"
        Goto put_n
      EndIf
      
      ;EX AF,AF' EXX - illegal
      If chk("^[\t, ]{1,}ex[\t, ]{1,}af,af'",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}exx[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      ;pchl
      If chk("^[\t, ]{1,}jp[\t, ]{1,}\(hl\)",ss)
        s=ReplaceString(s,"jp","pchl",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      If chk("^[\t, ]{1,}jp[\t, ]{1}[nz|z|nc|c|po|pe|p|m]",ss)
        ;jp nz,-jnz jp z,-jz,jnc-jp nc,jc-jp c,jp po, -jpo
        ;s=ReplaceString(s,"jp","",#PB_String_NoCase)
        
        If FindString(s,"nz,",0,#PB_String_NoCase)
          s=ReplaceString(s,"nz,","jnz ",#PB_String_NoCase)
          s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"z,",0,#PB_String_NoCase)
          s=ReplaceString(s,"z,","jz ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"nc,",0,#PB_String_NoCase)
          s=ReplaceString(s,"nc,","jnc ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"c,",0,#PB_String_NoCase)
          s=ReplaceString(s,"c,","jc ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"po,",0,#PB_String_NoCase)
          s=ReplaceString(s,"po,","jpo ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"pe,",0,#PB_String_NoCase)
          s=ReplaceString(s,"pe,","jpe ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"p,",0,#PB_String_NoCase)
          s=ReplaceString(s,"p,","jp ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        If FindString(s,"m,",0,#PB_String_NoCase)
          s=ReplaceString(s,"m,","jm ",#PB_String_NoCase)
        s=ReplaceString(s,"jp","",#PB_String_NoCase)
          Goto put_n
        EndIf
      EndIf
      
      If chk("^[\t, ]{1,}jp[\t, ]{1,}",ss)
        s=ReplaceString(s,"jp","jmp",#PB_String_NoCase,1,1)
        Goto put_n
      EndIf

      ;dad b d h sp -add hl,bc|de|hl|sp -add hl,(bc|de|hl|sp)
      If chk("^[\t, ]{1,}add[\t, ]{1,}hl,(bc|de|hl|sp)", ss)
        s=ReplaceString(s,"add","dad",#PB_String_NoCase)
        s=ReplaceString(s,"hl,","",#PB_String_NoCase)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase,FindString(s,"dad"+3))
        s=ReplaceString(s,"de","d",#PB_String_NoCase,FindString(s,"dad"+3))
        s=ReplaceString(s,"hl","h",#PB_String_NoCase,FindString(s,"dad"+3))
        Goto put_n
      EndIf

      ;adc/sbc hl,bc|de|hl|sp - illegal-(adc|sbc) hl,(bc|de|hl|sp)
      If chk("^[\t, ]{1,}(adc|sbc)[\t, ]{1,}hl,(bc|de|hl|sp)", ss)
        Goto illo
      EndIf

      If chk("^[\t, ]{1,}adc",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf

        If FindString(s,"a,",0,#PB_String_NoCase)
          s=ReplaceString(s,"a,","",#PB_String_NoCase)
        EndIf

        ;registers
        j=3+FindString(s,"adc",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        ;Debug s1+","
        j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            ;s=ReplaceString(s,"sbb","sbi",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"adc","aci",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      If chk("^[\t, ]{1,}add",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf

        If FindString(s,"a,",0,#PB_String_NoCase)
          s=ReplaceString(s,"a,","",#PB_String_NoCase)
        EndIf

        ;registers
        j=3+FindString(s,"add",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        ;Debug s1+","
        j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            Goto put_n
          Else
            s=ReplaceString(s,"add","adi",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
        EndIf

      ;sub (hl), sub N - sui N
      If chk("^[\t, ]{1,}sub",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        j=3+FindString(s,"sub",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        ;Debug s1+","
        j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            ;s=ReplaceString(s,"sbb","sbi",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"sub","sui",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      ;sbc abcdehl(hl) SBB,sbc N - sbi N
      If chk("^[\t, ]{1,}sbc",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf

        If FindString(s,"a,",0,#PB_String_NoCase)
          s=ReplaceString(s,"a,","",#PB_String_NoCase)
        EndIf

        ;registers
        j=3+FindString(s,"sbc",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        ;Debug s1+","
        j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"sbc","sbb",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"sbc","sbi",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      ;di/ei/nop/hlt - ok
      If chk("^[\t, ]{1,}di[\t, ]{0,}",ss):Goto put_n:EndIf
      If chk("^[\t, ]{1,}ei[\t, ]{0,}",ss):Goto put_n:EndIf
      If chk("^[\t, ]{1,}nop[\t, ]{0,}",ss):Goto put_n:EndIf

      ;inx b|d|h|sp - inc bc,de,hl,sp
      If chk("^[\t, ]{1,}inc[\t, ]{1,}(bc|de|hl|sp)", ss)
        s=ReplaceString(s,"inc","inx",#PB_String_NoCase)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase)
        s=ReplaceString(s,"de","d",#PB_String_NoCase)
        s=ReplaceString(s,"hl","h",#PB_String_NoCase)
        s=ReplaceString(s,"sp","sp",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;dcx b|d|h|sp - dec bc,de,hl,sp
      If chk("^[\t, ]{1,}dec[\t, ]{1,}(bc|de|hl|sp)", ss)
        s=ReplaceString(s,"dec","dcx",#PB_String_NoCase)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase)
        s=ReplaceString(s,"de","d",#PB_String_NoCase)
        s=ReplaceString(s,"hl","h",#PB_String_NoCase)
        s=ReplaceString(s,"sp","sp",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;inc (a|b|c|d|e|h|l|\(hl\))-INR
      If chk("^[\t, ]{1,}inc[\t, ]{1,}(a|b|c|d|e|h|l|\(hl\))", ss)
        s=ReplaceString(s,"inc","inr",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;dec (a|b|c|d|e|h|l|\(hl\))-DCR
      If chk("^[\t, ]{1,}dec[\t, ]{1,}(a|b|c|d|e|h|l|\(hl\))",ss)
        s=ReplaceString(s,"dec","dcr",#PB_String_NoCase)
        s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      ;daa-daa
      If chk("^[\t, ]{1,}daa[\t, ]{0,}",ss)
        Goto put_n
      EndIf
      
      ;cma-cpl
      If chk("^[\t, ]{1,}cpl[\t, ]{0,}",ss)
        s=ReplaceString(s,"cpl","cma",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      ;stc-scf
      If chk("^[\t, ]{1,}scf[\t, ]{0,}",ss)
        s=ReplaceString(s,"scf","stc",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      ;cmc-ccf
      If chk("^[\t, ]{1,}ccf[\t, ]{0,}",ss)
        s=ReplaceString(s,"ccf","cmc",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;neg-illegal
      If chk("^[\t, ]{1,}neg[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      ;shifts
      ;RLCA-RLC -- (rlca|rrca|rla|rra)
      ;RRCA-RRC
      ;RLA-RAL
      ;RRA-RAR
      If chk("(rlca|rrca|rla|rra)", ss)
        s=ReplaceString(s,"rlca","rlc",#PB_String_NoCase)
        s=ReplaceString(s,"rrca","rrc",#PB_String_NoCase)
        s=ReplaceString(s,"rla","ral",#PB_String_NoCase)
        s=ReplaceString(s,"rra","rar",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      ;check illegal
      If chk("^[\t, ]{1,}rld[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}rrd[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      ;(rlc|rl|rrc|) (a|b|c|d|e|h|l|\(hl\))
      If chk("^[\t, ]{1,}(rlc|rl|rrc|rr)[\t, ]{1,}(a|b|c|d|e|h|l|\(hl\))", ss)
        Goto illo
      EndIf
      
      ;and abcdehl(hl)-ANA N,ANI nn
       If chk("^[\t, ]{1,}and[\t, ]{0,}",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        j=3+FindString(s,"and",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"and","ana",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"and","ani",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      ;xor abcdehl(hl)-XRA, XRI nn
      If chk("^[\t, ]{1,}xor[\t, ]{0,}",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        j=3+FindString(s,"xor",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        ;Debug s1+","
        j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           ;Debug Mid(s1,j)+","
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"xor","xra",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"xor","xri",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf
      
      ;or abcdehl(hl)-ORA, ORI nn
      If chk("^[\t, ]{1,}or[\t, ]{0,}",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        j=3+FindString(s,"or",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         
         If j-1
           s1=Mid(s1,1,j-1)
         EndIf
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"or","ora",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"or","ori",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      ;CPI
      If chk("^[\t, ]{1,}cpi[\t, ]{0,}",ss)
        Goto illo
      EndIf
      ;CPIR
      If chk("^[\t, ]{1,}cpir[\t, ]{0,}",ss)
        Goto illo
      EndIf
      ;CPD
      If chk("^[\t, ]{1,}cpd[\t, ]{0,}",ss)
        Goto illo
      EndIf
      ;CPDR
      If chk("^[\t, ]{1,}cpdr[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      ;cp abcdehl(hl)-CMP
      If chk("^[\t, ]{1,}cp[\t, ]{1,}",ss)
        If FindString(s,"(hl)",0,#PB_String_NoCase)
          s=ReplaceString(s,"(hl)","m",#PB_String_NoCase)
        EndIf
        ;registers
        j=3+FindString(s,"cp",0,#PB_String_NoCase)
        s1.s=UCase(Mid(s,j))
        j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)<>Chr(9) And Mid(s1,j,1)<>" "
         s1=Mid(s1,j)
         j=0
         Repeat
           j+1
           If j=Len(s1):Break:EndIf
         Until Mid(s1,j,1)=Chr(9) Or Mid(s1,j,1)=" "
         

         s1=Trim( ReplaceString(s1,Chr(9),"") )
          If s1="A" Or s1="B" Or s1="C" Or s1="D" Or s1="E" Or s1="H" Or s1="L" Or s1="M"
            s=ReplaceString(s,"cp","cmp",#PB_String_NoCase,1,1)
            Goto put_n
          Else
            s=ReplaceString(s,"cp","cpi",#PB_String_NoCase,1,1)
            Goto put_n
          EndIf
      EndIf

      ; jr branches djnz
      If chk("^[\t, ]{1,}jr[\t, ]{1,}",ss)
        Goto illo
      EndIf

      If chk("^[\t, ]{1,}djnz[\t, ]{1,}",ss)
        Goto illo
      EndIf

      ;call condition
      If chk("^[\t, ]{1,}call[\t, ]{1}[nz|z|nc|c|po|pe|p|m]",ss)
        ;cnz call nz,
        If FindString(s,"nz,",0,#PB_String_NoCase)
          s=ReplaceString(s,"nz,","cnz ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf

        ;cz call z,
        If FindString(s,"z,",0,#PB_String_NoCase)
          s=ReplaceString(s,"z,","cz ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf

        ;     ;cnc call nc,
        If FindString(s,"nc,",0,#PB_String_NoCase)
          s=ReplaceString(s,"nc,","cnc ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;     ;cc call c,
        If FindString(s,"c,",0,#PB_String_NoCase)
          s=ReplaceString(s,"c,","cc ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;cpo call po,
        If FindString(s,"po,",0,#PB_String_NoCase)
          s=ReplaceString(s,"po,","cpo ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;     ;cpe call pe,
        If FindString(s,"pe,",0,#PB_String_NoCase)
          s=ReplaceString(s,"pe,","cpe ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;     ;cp call p,
        If FindString(s,"p,",0,#PB_String_NoCase)
          s=ReplaceString(s,"p,","cp ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;     ;cm call m,
        If FindString(s,"m,",0,#PB_String_NoCase)
          s=ReplaceString(s,"m,","cm ",#PB_String_NoCase)
        s=ReplaceString(s,"call","",#PB_String_NoCase)
          Goto put_n
        EndIf
      EndIf
      
      ;call
      If chk("^[\t, ]{1,}call[\t, ]{1,}",ss)
        Goto put_n
      EndIf
      
      ;ret condition
      If chk("^[\t, ]{1,}ret[\t, ]{1}[nz|z|nc|c|po|pe|p|m]",ss)
        s=ReplaceString(s,"ret","",#PB_String_NoCase)
        
        ;rnz ret nz
        If FindString(s,"nz",0,#PB_String_NoCase)
          s=ReplaceString(s,"nz","rnz",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rz ret z
        If FindString(s,"z",0,#PB_String_NoCase)
          s=ReplaceString(s,"z","rz",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rnc ret nc
        If FindString(s,"nc",0,#PB_String_NoCase)
          s=ReplaceString(s,"nc","rnc",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rc ret c
        If FindString(s,"c",0,#PB_String_NoCase)
          s=ReplaceString(s,"c","rc",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rpo ret po
        If FindString(s,"po",0,#PB_String_NoCase)
          s=ReplaceString(s,"po","rpo",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rpe ret pe
        If FindString(s,"pe",0,#PB_String_NoCase)
          s=ReplaceString(s,"pe","rpe",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rp ret p
        If FindString(s,"p",0,#PB_String_NoCase)
          s=ReplaceString(s,"p","rp",#PB_String_NoCase)
          Goto put_n
        EndIf
        
        ;rm ret m
        If FindString(s,"m",0,#PB_String_NoCase)
          s=ReplaceString(s,"m","rm",#PB_String_NoCase)
          Goto put_n
        EndIf
        
      EndIf
      
      ;reti retn -illegal
      If chk("^[\t, ]{1,}reti[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}retn[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}ret[\t, ]{0,}",ss)
        Goto put_n
      EndIf

      ;rst 0 1 2 3 4 5 6 7 rst 0 8 10h 18h 20h 28h 30h 38h
      ;rst [0-9a-fA-F]+h*
      If chk("rst[\t, ]{1}[0-9a-fA-F]+h*", ss)
        Goto illo
      EndIf
      
      ;push bc,de,hl,af
      If chk("^[\t, ]{1,}push[\t, ]{1,}[bc|de|hl|af]",ss)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase)
        s=ReplaceString(s,"de","d",#PB_String_NoCase)
        s=ReplaceString(s,"hl","h",#PB_String_NoCase)
        s=ReplaceString(s,"af","psw",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;pop bc,de,hl,af
      If chk("^[\t, ]{1,}pop[\t, ]{1,}[bc|de|hl|af]",ss)
        s=ReplaceString(s,"bc","b",#PB_String_NoCase)
        s=ReplaceString(s,"de","d",#PB_String_NoCase)
        s=ReplaceString(s,"hl","h",#PB_String_NoCase)
        s=ReplaceString(s,"af","psw",#PB_String_NoCase)
        Goto put_n
      EndIf

      ;INI INIR IND INDR OUTI OTIR OUTD OTDR-illegal
      ;IN OUT

      ;INI INIR IND INDR;in[id]r*
      If chk("^[\t, ]{1,}in[id]r*", ss)
        Goto illo
      EndIf

      ;in (a|b|c|d|e|h|l)\x2C\(c\)
      If chk("^[\t, ]{1,}in (a|b|c|d|e|h|l)\x2C\(c\)", ss)
        Goto illo
      EndIf
      
      ;in a,(byte) IN byte
      If chk("^[\t, ]{1,}in[\t, ]{0,}a\,\(",ss)
        s=ReplaceString(s,"a,(","",#PB_String_NoCase)
        s=ReplaceString(s,")","",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      
      ;OUTI OTIR OUTD OTDR
      If chk("^[\t, ]{1,}outi[\t, ]{0,}",ss)
        Goto illo;put_n
      EndIf
      
      If chk("^[\t, ]{1,}otir[\t, ]{0,}",ss)
        Goto illo;put_n
      EndIf
      
      If chk("^[\t, ]{1,}outd[\t, ]{0,}",ss)
        Goto illo;put_n
      EndIf
      
      If chk("^[\t, ]{1,}otdr[\t, ]{0,}",ss)
        Goto illo;put_n
      EndIf
      
      ;out (c),a - out \(c\)\x2C(a|b|c|d|e|h|l)
      If chk("^[\t, ]{1,}out \(c\)\x2C(a|b|c|d|e|h|l)", ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}out[\t, ]{1,}\(.*?\)\,a",ss)
        s=ReplaceString(s,"),a","",#PB_String_NoCase)
        s=ReplaceString(s,"(","",#PB_String_NoCase)
        Goto put_n
      EndIf
      
      ;LDI LDIR LDD LDDR;ld[id]r*
      If chk("^[\t, ]{1,}ld[id]r*", ss)
        Goto illo
      EndIf
      
      ;bit/res/set 0-7,r8 (bit|set|res) [0-7]\x2C(a|b|c|d|e|h|l|\(hl\))
      If chk("(bit|set|res) [0-7]\x2C(a|b|c|d|e|h|l|\(hl\))", ss)
        Goto illo
      EndIf
      
      ;sla/sra/srl - illegal
      If chk("^[\t, ]{1,}sla[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}sra[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
      If chk("^[\t, ]{1,}srl[\t, ]{0,}",ss)
        Goto illo
      EndIf
      
illo:
s="; cannot convert:"+s
ernum+1
put_n:
s=l$+s+co$
AddGadgetItem(#s2,-1,s)
Next i

If ernum
;colors
For i=0 To ln
  s.s=GetGadgetItemText(#s2,i);17
  If Mid(s,1,17)="; cannot convert:"
    edc=255
  Else
    edc=0
  EndIf
    sb=SendMessage_(GadgetID(#s2),#EM_LINEINDEX,i,0)
    If sb<>-1
      SendMessage_(GadgetID(#s2),#EM_SETSEL,sb,sb+Len(s)+1)
      Editor_Color(#s2,edc)
    EndIf;sb<>-1
Next i
      SendMessage_(GadgetID(#s2),#EM_SETSEL,-1,-1)
      SendMessage_(GadgetID(#s2), #EM_SCROLL, #SB_TOP, 0)
      MessageRequester("Convert","Errors:"+Str(ernum))
EndIf
  EndIf
EndProcedure



Procedure convert2();8080->z80
  
  ClearGadgetItems(#s1)
  ln=CountGadgetItems(#s2);amount of lines
  If ln>0
    For i=0 To ln
      ;s.s=mytrim(GetGadgetItemText(#s2,i))
      s.s=GetGadgetItemText(#s2,i)
      ;Debug s
      ;комментарии
      l$=""
      co$=""
      p=FindString(s,";")
      If p
        co$=Mid(s,p)
        s=Mid(s,1,p-1)
      EndIf
      
      If Trim (mytrim(s) )=""
        Goto put_t
      EndIf
      
      ; тест на метки
      If FindString("abcdefghijklmnopqrstuvwxyz",LCase(Mid(s,1,1)),0,#PB_String_NoCase)
;поиск метки
        j=1
        Repeat
          j+1
          If j=Len(s):Break:EndIf
        Until Mid(s,j,1)=Chr(9) Or Mid(s,j,1)=" "
        If j=Len(s)
          l$=s
          s=""
          Goto put_t
        EndIf
        l$=Mid(s,1,j)
        s=Mid(s,j)
;equals
        If FindString(s,"equ",1,#PB_String_NoCase)
          Goto put_t
        EndIf
        If FindString(s,"=",1,#PB_String_NoCase)
          Goto put_t
        EndIf
      EndIf  
      
      If chk("^[\t, ]{1,}db[\t, ]{1,}", s)
        Goto put_t
      EndIf
      If chk("^[\t, ]{1,}dw[\t, ]{1,}", s)
        Goto put_t
      EndIf
      If chk("^[\t, ]{1,}ds[\t, ]{1,}", s)
        Goto put_t
      EndIf
      
      ;If FindString(LCase(s),"cmp")
      If chk("^[\t, ]{1,}cmp[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"cmp","cp",#PB_String_NoCase,1,1)
        j=FindString(LCase(s),"m")
        If j
          If j<Len(s)
            If Mid(s,j+1,1)=" " Or Mid(s,j+1,1)=";" Or Mid(s,j+1,1)=Chr(9)
              s=ReplaceString(s,"m","(hl)",#PB_String_NoCase,1,1)
            EndIf
          Else
            s=ReplaceString(s,"m","(hl)",#PB_String_NoCase,1,1)
          EndIf
        EndIf
        Goto put_t
      EndIf
      ;Debug s      
      ;      If FindString(LCase(s),"cpi")
      If chk("^[\t, ]{1,}cpi[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"cpi","cp",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf


      If chk("^[\t, ]{1,}mov[\t, ]{1,}[a|b|c|d|e|h|l|m],", s);LCase(s))
        s=ReplaceString(s,"mov","ld",#PB_String_NoCase)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase,FindString(s,"ld"),1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}ldax[\t, ]{1,}b", s);LCase(s))
        s=ReplaceString(s,"ldax","ld a,",#PB_String_NoCase)
        s=ReplaceString(s,"b","(bc)",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}ldax[\t, ]{1,}d", s);LCase(s))
        s=ReplaceString(s,"ldax","ld a,",#PB_String_NoCase)
        s=ReplaceString(s,"d","(de)",#PB_String_NoCase,FindString(s,"ld a")+4)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}lda[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"lda","ld",#PB_String_NoCase,1,1)
        j=FindString(s,"ld")+2
        Repeat
          j+1
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9)
        s=InsertString(s,"a,(",j)
        ;        Debug s
        j+2
        Repeat
          j+1
        If j>Len(s):Break:EndIf
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9); Or j>Len(s)
        s=InsertString(s,")",j)
        ;        Debug s
        
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}mvi[\t, ]{1,}[a|b|c|d|e|h|l|m],", s);LCase(s))
        s=ReplaceString(s,"mvi","ld",#PB_String_NoCase,1,1)
        ;m->(hl)
        s=ReplaceString(s,"m,","(hl),",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}stax[\t, ]{1,}[b|d]", s);LCase(s))
        s=ReplaceString(s,"stax","ld",#PB_String_NoCase)
        If FindString(LCase(s),"b")
        s=ReplaceString(s,"b","(bc),a",#PB_String_NoCase,FindString(s,"ld")+2,1)
        Else;Debug s
        s=ReplaceString(s,"d","(de),a",#PB_String_NoCase,FindString(s,"ld")+2,1)
        EndIf;Debug s
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}sta[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"sta","ld",#PB_String_NoCase,1,1)
        j=FindString(s,"ld")+1
        
        Repeat
          j+1
          If j>Len(s):Break:EndIf
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9)
        
        s=InsertString(s,"(",j)
        Repeat
          j+1
          If j>Len(s):Break:EndIf
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9)
        s=InsertString(s,"),a",j)
        Goto put_t
      EndIf
      
      
      If chk("^[\t, ]{1,}lxi[\t, ]{1,}[b|d|h|sp]", s);LCase(s)); , removed
        s=ReplaceString(s,"lxi","ld",#PB_String_NoCase)
        s=ReplaceString(s,"b,","bc,",#PB_String_NoCase,FindString(s,"ld")+2)
        s=ReplaceString(s,"d,","de,",#PB_String_NoCase,FindString(s,"ld")+2)
        s=ReplaceString(s,"h,","hl,",#PB_String_NoCase,FindString(s,"ld")+2)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}lhld[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"lhld","ld",#PB_String_NoCase,1,1)
        j=FindString(s,"ld")+2
        Repeat
          j+1
          ;Debug Mid(s,j)+"="+Str(Asc(Mid(s,j)))
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9)
        s=InsertString(s,"hl,(",j)
        ;        Debug s
        ;j+4
        Repeat
          j+1
          ;Debug Mid(s,j)+"="+Str(Asc(Mid(s,j)))
          If j>Len(s):Break:EndIf
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9); Or j>Len(s)
        s=InsertString(s,")",j)
        ;        Debug s
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}shld[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"shld","ld",#PB_String_NoCase,1,1)
        j=FindString(s,"ld")+2
        Repeat
          j+1
          ;Debug Mid(s,j)+"="+Str(Asc(Mid(s,j)))
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9)
        s=InsertString(s,"(",j)
         ;Debug s
        Repeat
          j+1
          ;Debug Mid(s,j)+"="+Str(Asc(Mid(s,j)))
          If j>Len(s):Break:EndIf
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9); Or j>Len(s)
        s=InsertString(s,"),hl",j)
        ;Debug s
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}sphl[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"sphl","ld sp,hl",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}xchg[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"xchg","ex de,hl",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}xthl[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"xthl","ex (sp),hl",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("[\t, ]{1,}dad[\t, ]{1,}[b|d|h|sp]", s);LCase(s))
        s=ReplaceString(s,"dad","add",#PB_String_NoCase)
        s=ReplaceString(s,"h","hl,hl",#PB_String_NoCase,FindString(s,"add")+3,1)
        s=ReplaceString(s,"b","hl,bc",#PB_String_NoCase,FindString(s,"add")+3,1)
        s=ReplaceString(s,"d","hl,de",#PB_String_NoCase,FindString(s,"add")+3,1)
        s=ReplaceString(s,"sp","hl,sp",#PB_String_NoCase,FindString(s,"add")+3,1)
        Goto put_t
      EndIf

      ;xra/xri
      If chk("^[\t, ]{1,}xri[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"xri","xor",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}xra[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"xra","xor",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;ora/ori
      If chk("^[\t, ]{1,}ori[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"ori","or",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}ora[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"ora","or",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf

      ;ana/ani
      If chk("^[\t, ]{1,}ani[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"ani","and",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}ana[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"ana","and",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf

      ;add/adi
      If chk("^[\t, ]{1,}adi[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"adi","add a,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf

      If chk("[\t, ]{1,}add[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"add","add a,",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;adc/aci
      If chk("^[\t, ]{1,}aci[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"aci","adc a,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}adc[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"adc","adc a,",#PB_String_NoCase,1,1)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;sub/sui
      If chk("^[\t, ]{1,}sui[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"sui","sub",#PB_String_NoCase)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}sub[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;sbb/sbi
      If chk("^[\t, ]{1,}sbi[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"sbi","sbc",#PB_String_NoCase)
        Goto put_t
      EndIf
      If chk("[\t, ]{1,}sbb[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"sbb","sbc",#PB_String_NoCase)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;INR
      If chk("[\t, ]{1,}inr[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"inr","inc",#PB_String_NoCase)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase);m->(hl)
        Goto put_t
      EndIf
      
      ;DCR
      If chk("[\t, ]{1,}dcr[\t, ]{1,}(a|b|c|d|e|h|l|m)", s);LCase(s))
        s=ReplaceString(s,"dcr","dec",#PB_String_NoCase)
        s=ReplaceString(s,"m","(hl)",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("[\t, ]{1,}inx[\t, ]{1,}[b|d|h|sp]", s);LCase(s))
        s=ReplaceString(s,"inx","inc",#PB_String_NoCase)
        s=ReplaceString(s,"h","hl",#PB_String_NoCase,FindString(s,"inc")+3)
        s=ReplaceString(s,"b","bc",#PB_String_NoCase,FindString(s,"inc")+3)
        s=ReplaceString(s,"d","de",#PB_String_NoCase,FindString(s,"inc")+3)
        Goto put_t
      EndIf
      
      If chk("[\t, ]{1,}dcx[\t, ]{1,}[b|d|h|sp]", s);LCase(s))
        s=ReplaceString(s,"dcx","dec",#PB_String_NoCase)
        s=ReplaceString(s,"h","hl",#PB_String_NoCase,FindString(s,"dec")+3)
        s=ReplaceString(s,"b","bc",#PB_String_NoCase,FindString(s,"dec")+3)
        s=ReplaceString(s,"d","de",#PB_String_NoCase,FindString(s,"dec")+3)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}daa[\t, ]{0,}", s);LCase(s))
        Goto put_t
      EndIf

      If chk("^[\t, ]{1,}cma[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cma","cpl",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}stc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"stc","scf",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cmc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cmc","ccf",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      ;rlc-rlca
      If chk("^[\t, ]{1,}rlc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rlc","rlca",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      ;rrc-rrca
      If chk("^[\t, ]{1,}rrc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rrc","rrca",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      ;ral-rla
      If chk("^[\t, ]{1,}ral[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"ral","rla",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      ;rar-rra
      If chk("^[\t, ]{1,}rar[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rar","rra",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      
      ;jumps
      
      If chk("^[\t, ]{1,}pchl[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"pchl","jp (hl)",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf

      If chk("^[\t, ]{1,}jmp[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jmp","jp",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jnz[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jnz","jp nz,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jz[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jz","jp z,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jnc[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jnc","jp nc,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jc[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jc","jp c,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jpo[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jpo","jp po,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jpe[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jpe","jp pe,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}jm[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jm","jp m,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf

      If chk("^[\t, ]{1,}jp[\t, ]{1,}", s);LCase(s))
        s=ReplaceString(s,"jp","jp p,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf

      
      ;calls
      If chk("^[\t, ]{1,}call[\t, ]{1,}", s);LCase(s))
        Goto put_t
      EndIf

      If chk("^[\t, ]{1,}cnz[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cnz","call nz,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cz[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cz","call z,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cnc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cnc","call nc,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cc","call c,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cpo[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cpo","call po,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cpe[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cpe","call pe,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cp[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cp","call p,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}cm[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"cm","call m,",#PB_String_NoCase,1,1)
        Goto put_t
      EndIf
      
      ;rets
      If chk("^[\t, ]{1,}ret[\t, ]{0,}", s);LCase(s))
        Goto put_t
      EndIf

      If chk("^[\t, ]{1,}rnz[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rnz","ret nz",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rz[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rz","ret z",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rnc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rnc","ret nc",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rc[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rc","ret c",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rpo[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rpo","ret po",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rpe[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rpe","ret pe",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rp[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rp","ret p",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      If chk("^[\t, ]{1,}rm[\t, ]{0,}", s);LCase(s))
        s=ReplaceString(s,"rm","ret m",#PB_String_NoCase)
        Goto put_t
      EndIf
      
      
      ;rst 0-7
      ;push bc,de,hl,af -[\t, ]{1,}push[\t, ]{1,}[b|d|h]
      If chk("push[\t, ]{1,}[b|d|h|psw]",s)
        s=ReplaceString(s,"b","bc",#PB_String_NoCase,FindString(s,"push",1,#PB_String_NoCase)+4)
        s=ReplaceString(s,"d","de",#PB_String_NoCase,FindString(s,"push",1,#PB_String_NoCase)+4)
        s=ReplaceString(s,"h","hl",#PB_String_NoCase,FindString(s,"push",1,#PB_String_NoCase)+4)
        s=ReplaceString(s,"psw","af",#PB_String_NoCase,FindString(s,"push",1,#PB_String_NoCase)+4)
        Goto put_t
      EndIf
      
      ;pop bc,de,hl,af
      If chk("pop[\t, ]{1,}[b|d|h|psw]",s)
        s=ReplaceString(s,"b","bc",#PB_String_NoCase,FindString(s,"pop",#PB_String_NoCase )+3)
        s=ReplaceString(s,"d","de",#PB_String_NoCase,FindString(s,"pop",#PB_String_NoCase )+3)
        s=ReplaceString(s,"h","hl",#PB_String_NoCase,FindString(s,"pop",#PB_String_NoCase )+3)
        s=ReplaceString(s,"psw","af",#PB_String_NoCase,FindString(s,"pop",#PB_String_NoCase )+3)
        Goto put_t
      EndIf
      
      ;in byte in a,(byte)  in rnc - buggy
      If chk("^[\t, ]{1,}in[\t, ]{1,}", s);LCase(s))
        j=FindString(s,"in",1,#PB_String_NoCase)+2
        Repeat
          j+1
          If j>Len(s):Break:EndIf; or =?
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9); And j<Len(s)
        s=InsertString(s,"a,(",j)
        ;Debug Len(s)
        Repeat
          j+1
          If j>Len(s):Break:EndIf
          ;Debug Mid(s,j)+","+Str( Asc( Mid(s,j,1) ) )
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9); Or j>Len(s)
        s=InsertString(s,")",j)
        Goto put_t
      EndIf
      
      ;out byte out (byte),a
      If chk("^[\t, ]{1,}out[\t, ]{1,}", s);LCase(s))
        j=FindString(s,"out",1,#PB_String_NoCase)+3
        Repeat
          j+1
        Until Mid(s,j,1)<>" " And Mid(s,j,1)<>Chr(9) And j<Len(s)
        s=InsertString(s,"(",j)
        
        ;Debug Mid (s,j)
        Repeat
          j+1
          ;Debug Mid (s,j)+","+Str(j)
          If j>Len(s):Break:EndIf
        Until Mid(s,j,1)=" " Or Mid(s,j,1)=Chr(9); Or j<Len(s)
        s=InsertString(s,"),a",j)
        Goto put_t
      EndIf
      
      If FindString(LCase(s),"[\t, ]{1,}di[\t, ]{0,}")
        Goto put_t
      EndIf
      If FindString(LCase(s),"[\t, ]{1,}ei[\t, ]{0,}")
        Goto put_t
      EndIf

cant:
s=";Cannot convert:"+s
put_t:
Editor_Color(#s1,edc)
    Next i
  EndIf
  Editor_Color(#s1,0)
EndProcedure

Procedure CustomButtonCallback(WindowHandle, Message, WParam, LParam) 
  Shared DefaultButtonCallback
  
  If Message = #WM_CONTEXTMENU
    DisplayPopupMenu(0, WindowID(#s1))
  EndIf
  
  ProcedureReturn CallWindowProc_(DefaultButtonCallback, WindowHandle, Message, WParam, LParam) 
EndProcedure

Procedure CustomButtonCallback2(WindowHandle, Message, WParam, LParam) 
  Shared DefaultButtonCallback
  
  If Message = #WM_CONTEXTMENU
    DisplayPopupMenu(1, WindowID(#s1))
  EndIf
  
  ProcedureReturn CallWindowProc_(DefaultButtonCallback, WindowHandle, Message, WParam, LParam) 
EndProcedure

OpenWindow(0, 0, 0, 640, 480, "z80<->8080, 1.0d /Shiny/2o18-2o22", #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
EditorGadget(#s1,0,20,300,400)

ButtonGadget(#bc1,300,22,20,20,">"):GadgetToolTip(#bc1,"convert z80 to 8080")

ButtonGadget(#bc2,300,124,20,20,"<"):GadgetToolTip(#bc2,"convert 8080 to z80")

TextGadget(#lz80,0,0,300,20,"z80 code", #PB_Text_Center | #PB_Text_Border)

EditorGadget(#s2,320,20,320,400);,#PB_Editor_WordWrap);:GadgetToolTip(#s2,"8080 code")
TextGadget(#l8080,320,0,320,20,"8080 code", #PB_Text_Center | #PB_Text_Border)


EnableGadgetDrop(#s1,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#s2,#PB_Drop_Files,#PB_Drag_Copy)

If CreatePopupMenu(0)
  MenuItem(0, "Cut")
  MenuItem(1, "Copy")
  MenuItem(2, "Paste")
  MenuBar()
  MenuItem(3, "Select all")
EndIf

If CreatePopupMenu(1)
  MenuItem(4, "Cut")
  MenuItem(5, "Copy")
  MenuItem(6, "Paste")
  MenuBar()
  MenuItem(7, "Select All")
EndIf


DefaultButtonCallback = GetWindowLongPtr_(GadgetID(#s1), #GWL_WNDPROC) 
SetWindowLongPtr_(GadgetID(#s1), #GWL_WNDPROC, @CustomButtonCallback())

DefaultButtonCallback = GetWindowLongPtr_(GadgetID(#s2), #GWL_WNDPROC) 
SetWindowLongPtr_(GadgetID(#s2), #GWL_WNDPROC, @CustomButtonCallback2())
Exit = #False

Repeat
  Event = WaitWindowEvent()
  ;  Event = WindowEvent()
  
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    Exit = #True
  EndIf
  
  Select Event
    Case #PB_Event_CloseWindow
      Exit = #True
      
    Case #PB_Event_Menu
      Select EventMenu()
        Case 0
          SendMessage_(GadgetID(#s1), #WM_CUT, 0, 0)
        Case 1
          SendMessage_(GadgetID(#s1), #WM_COPY, 0, 0)
        Case 3
          ll=Len(GetGadgetText(#s1))
          SendMessage_(GadgetID(#s1), #EM_SETSEL, 0, ll)
        Case 2
          SendMessage_(GadgetID(#s1), #WM_PASTE, 0, 0)
          
        Case 4
          SendMessage_(GadgetID(#s2), #WM_CUT, 0, 0)
        Case 5
          SendMessage_(GadgetID(#s2), #WM_COPY, 0, 0)
        Case 7
          ll=Len(GetGadgetText(#s2))
          SendMessage_(GadgetID(#s2), #EM_SETSEL, 0, ll)
        Case 6
          SendMessage_(GadgetID(#s2), #WM_PASTE, 0, 0)
          
      EndSelect
      
    Case #PB_Event_GadgetDrop
      Select EventGadget()
        Case #s1 To #s2
          gd=EventGadget()
          ClearGadgetItems(gd)
          d$=EventDropFiles()
          ;Debug d$
          If ReadFile(0,d$)
            While Not Eof(0)
              AddGadgetItem(gd,-1,ReadString(0))
            Wend
            CloseFile(0)
          EndIf
          
      EndSelect
      
    Case #PB_Event_Gadget
      ID = EventGadget()
      Select ID
        Case #s2
          If EventType() = 1024
            HoldLine = SendMessage_(GadgetID(#s2), #EM_GETFIRSTVISIBLELINE, 0, 0)
            CurrentLine = SendMessage_(GadgetID(#s1), #EM_GETFIRSTVISIBLELINE, 0, 0)
            lResult = SendMessage_(GadgetID(#s1), #EM_LINESCROLL, 0, HoldLine - CurrentLine)
          EndIf
          
        Case #s1
          If EventType() = 1024
            HoldLine = SendMessage_(GadgetID(#s1), #EM_GETFIRSTVISIBLELINE, 0, 0)
            CurrentLine = SendMessage_(GadgetID(#s2), #EM_GETFIRSTVISIBLELINE, 0, 0)
            lResult = SendMessage_(GadgetID(#s2), #EM_LINESCROLL, 0, HoldLine - CurrentLine)
          EndIf
          
        Case #bc1
          convert();convert z80 to 8080
        Case #bc2
          convert2();convert 8080 to z80
      EndSelect
  EndSelect
  
Until Exit

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 99
; FirstLine = 99
; Folding = --
; EnableXP
; UseIcon = z80-80802.ico
; Executable = z808080.exe